// *********************************************************
// curses library example program.
// for curses info type>>     man ncurses
// *********************************************************
#include <stdlib.h>
#include <iostream.h>
#include <iomanip.h>
#include <math.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <ncurses.h>
#include <limits.h>
#include <unistd.h>
#define LEN 1000
//#define DEBUG yes

void main( void )
{
   int b,x=0;
   char a;
   int max=50;
   WINDOW *scr;
   int hand;     //used to store the opened file pointer
   cout<<"init screen returned -"<<scr<<"\n";
   cout<<"starting curses \033[33m \033[44m";
   sleep(1);
   scr=initscr();	// start curses
   // wattrset(scr,1);		// changes the screen attributes (messes it up!)
   // bkgdset('.');			// set background character
   noecho();				// ncurses library stop echo
   start_color();	// curses
   if(!has_colors()){
		       // 	       endwin();
		       cout<<"we have no colors\n";
		       cout <<"colors="<<COLORS<<" color pairs="<<COLOR_PAIRS;
		       //	       goto fin;
		    }
   init_pair(2,COLOR_GREEN,COLOR_BLACK);		// init some color combos
   init_pair(3,COLOR_YELLOW,COLOR_BLACK);
   init_pair(4,COLOR_BLUE,COLOR_RED);
   init_pair(5,COLOR_MAGENTA,COLOR_WHITE);
   // COLOR_PAIR(22);
   color_set(5,0);
   border('|','|','-','_','/','\\','\\','/');	// draws a nice border on root window
   move(12,10);
   addstr("\n\t welcome to the ncurses demo\n");
   printw("\t screen size is %d X %d\n",COLS,LINES);
   color_set(2,0);
   printw("\t colors= %d color pairs= %d",COLORS,COLOR_PAIRS);
   mvaddch(1,1,'1');
   mvaddch(2,2,'2');
   printw("\n\t press a  key to continue");
   refresh();
   a=getch();
   nodelay(scr,TRUE);		// changes behavior of the getch function
   do{
	color_set(4,0);
	erase();		// curses erase screen
	mvaddstr(12,10,"press c to continue press + and - to change max \n");
	printw("\t\t max=%d",max);
	color_set(3,0);
	move(1,2);
	hline(219,max>>2);
	if(max&3)mvaddch(1,(max>>2)+2,(max&3)+175);	// nice fade tip effect

	move(2,1);
	vline(219,max>>2);
	if(max&3)mvaddch(2+(max/4),1,(max&3)+175);	// nice fade tip effect

	refresh();
	a=getch();
	if(a=='+')max++;
	if(a=='-')max--;
     }while(a!='c'&&a!='C');

   erase();		// curses erase screen
   move(2,3);
   addstr("So you want some more ascii characters to play with ee ...");
   for(int x=0;x<=15;x++){
			    for(b=0;b<=15;b++)mvaddch(3+x,4+(b*2),x*16+b);
			    printw("  %d",x*16);
			 }
   color_set(2,0);
   addstr("\n\t Then have some more ascii characters");
   addstr("\n\n\t Dare you press a key to continue...");
   nodelay(scr,FALSE);		// changes behavior of the getch function
   do{
	refresh();
	a=getch();
	mvprintw(19,3,"The ascii value of the key you pressed=%d  ",a);
     }while(a!='a');
   color_set(4,0);
   erase();		// curses erase screen
   move(4,4);
   addstr("So you want some more ea well then have some more.\n");
   for(int b=0;b<100;b++){
			    for(int a=0;a<13;a++){
						    //a=b%77;
						    mvaddch(a+11,12,'h'+b%5);
						    hline('*'+b%13,b%45);
						 }
			    refresh();
			 }
   endwin();
   // refresh();	// this last refresh will restore the original screen
   fin:
      exit;
}

